﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=9.801
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	#ExcludeFromLibrary: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Dim start,check As HttpJob
End Sub

Sub Service_Create
	'This is the program entry point.
	'This is a good place to load resources that are not specific to a single activity.
End Sub

Sub Service_Start (StartingIntent As Intent)
	Service.StopAutomaticForeground 'Starter service can start in the foreground state in some edge cases.
	
	startReq
End Sub

Sub JobDone (Job As HttpJob)
	If Job.Success = True Then
		'Dim webtxt As String = Job.GetString2("ISO-8859-1")
		
		Select Job.JobName
			Case "test":
				Dim fx As String = "FX:USOIL"
				
				Dim vals As Map
				vals.Initialize
				
				Dim symbols As Map
				symbols.Initialize
				
				Dim tickers As List
				tickers.Initialize
				tickers.Add(fx)
				
				Dim query As Map
				query.Initialize
				
				Dim types As List
				types.Initialize
				
				query.put("types",types)
				
				Dim columns As List
				columns.Initialize
				columns.Add("Recommend.Other|5")
				columns.Add("Recommend.All|5")
				columns.Add("Recommend.MA|5")
				
				symbols.Put("tickers",tickers)
				symbols.Put("query",query)
				
				vals.Put("symbols", symbols)
				vals.Put("columns",columns)
				
				Dim k As JSONGenerator
				k.Initialize(vals)
				Log(k.ToString)
				
'				"{" & Chr(34) & "symbols" & Chr(34) & ":{" & Chr(34) & "tickers" & Chr(34) & ":[" & Chr(34) & fx & Chr(34) & "]," & Chr(34) & "query" & Chr(34) & ":{" & Chr(34) & "types" & Chr(34) & ":[]}}," & Chr(34) & "columns" & Chr(34) & ":[" & Chr(34) & "Recommend.Other|15" & Chr(34) & "," & Chr(34) & "Recommend.All|15" & Chr(34) & "," & Chr(34) & "Recommend.MA|15" & Chr(34) & "]}"
				check.Initialize("values", Me)
				check.PostString("https://scanner.tradingview.com/forex/scan", k.tostring)
'				check.PostMultipart("https://scanner.tradingview.com/forex/scan", vals, Null)
				check.GetRequest.SetHeader("Accept","*/*")
				check.GetRequest.SetContentEncoding("gzip, deflate, br")
				check.GetRequest.SetHeader("Accept-Language", "de,en-US;q=0.7,en;q=0.3")
				check.GetRequest.SetHeader("Cache-Control","no-cache")
				check.GetRequest.SetHeader("Connection","keep-alive")
				check.GetRequest.SetContentType("application/x-www-form-urlencoded")
				check.GetRequest.SetHeader("DNT","1")
				check.GetRequest.SetHeader("Host", "scanner.tradingview.com")
				check.GetRequest.SetHeader("Origin", "https://tradingview.com")
				check.GetRequest.SetHeader("Pragma", "no-cache")
				check.GetRequest.SetHeader("TE", "Trailers")
				check.GetRequest.SetHeader("User-Agent","Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:77.0) Gecko/20100101 Firefox/77.0")
				Log("Daten?")
			Case "values":
'				Dim j As JSONParser
'				j.Initialize(Job.GetString)
				Log(Job.GetString)
'				Dim m,n As Map
'				m.Initialize
'				n.Initialize
'				m = j.NextObject
'				n = m.Get("d")
'				Log(n)
'				Dim res As List
'				res.Initialize
'				res = n
'				For Each t As String In m.keys
'					Log(t)
'				Next
'				For i = 0 To res.Size - 1
'					Log(res.Get(i))
'				Next
		End Select
	Else
		Log(Job.ErrorMessage)
	End If
	Job.release
End Sub

Sub startReq()
	start.Initialize("",Me)
	start.Download("https://tradingview.com/symbols/USOIL/technicals/")
	start.GetRequest.SetHeader("Accept","text/html,application/xhtml+xml,application/xml;q=0.9,image/webp,*/*;q=0.8")
	start.GetRequest.SetContentEncoding("gzip, deflate, br")
	start.GetRequest.SetHeader("Accept-Language", "de,en-US;q=0.7,en;q=0.3")
	start.GetRequest.SetHeader("Cache-Control","no-cache")
	start.GetRequest.SetHeader("Connection","keep-alive")
	start.GetRequest.SetHeader("DNT","1")
	start.GetRequest.SetHeader("Host", "tradingview.com")
	start.GetRequest.SetHeader("Upgrade-Insecure-Requests", "1")
	start.GetRequest.SetHeader("Pragma", "no-cache")
	start.GetRequest.SetHeader("User-Agent","Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:77.0) Gecko/20100101 Firefox/77.0")
	
	wait for (start) JobDone(job As HttpJob)
	If job.success Then
		getData(start)
	Else
		Log("Error:")
		Log(job.ErrorMessage)
	End If
	job.release
End Sub

Sub getData(jo As HttpJob)
	Dim fx As String = "FX:USOIL"
				
	Dim vals As Map
	vals.Initialize
				
	Dim symbols As Map
	symbols.Initialize
				
	Dim tickers As List
	tickers.Initialize
	tickers.Add(fx)
				
	Dim query As Map
	query.Initialize
				
	Dim types As List
	types.Initialize
				
	query.put("types",types)
				
	Dim columns As List
	columns.Initialize
	columns.AddAll(Array As String("Recommend.Other|5","Recommend.All|5","Recommend.MA|5"))
				
	symbols.Put("tickers",tickers)
	symbols.Put("query",query)
				
	vals.Put("symbols", symbols)
	vals.Put("columns",columns)
				
	Dim k As JSONGenerator
	k.Initialize(vals)
	Log(k.ToString)
				
'	"{" & Chr(34) & "symbols" & Chr(34) & ":{" & Chr(34) & "tickers" & Chr(34) & ":[" & Chr(34) & fx & Chr(34) & "]," & Chr(34) & "query" & Chr(34) & ":{" & Chr(34) & "types" & Chr(34) & ":[]}}," & Chr(34) & "columns" & Chr(34) & ":[" & Chr(34) & "Recommend.Other|15" & Chr(34) & "," & Chr(34) & "Recommend.All|15" & Chr(34) & "," & Chr(34) & "Recommend.MA|15" & Chr(34) & "]}"
	check.Initialize("", Me)
'	check.PostMultipart("https://scanner.tradingview.com/forex/scan", vals, Null)
	check.PostString("https://scanner.tradingview.com/forex/scan", k.tostring)
	check.GetRequest.SetHeader("Accept","*/*")
	check.GetRequest.SetContentEncoding("gzip, deflate, br")
	check.GetRequest.SetHeader("Accept-Language", "de,en-US;q=0.7,en;q=0.3")
	check.GetRequest.SetHeader("Cache-Control","no-cache")
	check.GetRequest.SetHeader("Connection","keep-alive")
	check.GetRequest.SetContentType("application/x-www-form-urlencoded")
	check.GetRequest.SetHeader("DNT","1")
	check.GetRequest.SetHeader("Host", "scanner.tradingview.com")
	check.GetRequest.SetHeader("Origin", "https://tradingview.com")
	check.GetRequest.SetHeader("Pragma", "no-cache")
	check.GetRequest.SetHeader("TE", "Trailers")
	check.GetRequest.SetHeader("User-Agent","Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:77.0) Gecko/20100101 Firefox/77.0")
	
	wait for (check) JobDone(job As HttpJob)
	If job.Success Then
		Log(job.GetString)
	Else
		Log("Error:")
		Log(job.ErrorMessage)
	End If
	
	job.release
End Sub

Sub quotes(txt As String) As String
	Return Chr(34) & txt & Chr(34)
End Sub

Sub Service_TaskRemoved
	'This event will be raised when the user removes the app from the recent apps list.
End Sub

'Return true to allow the OS default exceptions handler to handle the uncaught exception.
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub

Sub Service_Destroy

End Sub
